Imports System.Collections.ObjectModel
Imports Model.Interfaces

Namespace MyERP2Model
    Partial Public Class ContactBase
        Inherits ModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp
        Implements IProtocolable

#Region "Mapped"
        Public Property Id As Guid
        Public Property SupplierId As Guid?
        Public Property ClientId As Guid?
        Public Property Name1 As String
        Public Property Name2 As String
        Public Property Name3 As String
        Public Property Email As String
        Public Property Web As String
        Public Property Phone As String
        Public Property Fax As String
        Public Property VatNo As String
        Public Property VatnoLastCheck As Date?
        Public Property Jurisdiction As String
        Public Property FbNo As String
        Public Property DvrNo As String
        Public Property Typ As Integer?
        Public Property EmployerCount As Integer?
        Public Property LegalformId As Guid?
        Public Property Capital As Decimal?
        Public Property LanguageId As Guid?
        Public Property OwningUserId As Guid?
        Public Property IncotermsId As Guid?
        Public Property IncotermsComment As String
        Public Property CurrencyId As Guid?
        Public Property Logo As Byte()
        Public Property PosDiscountAllowed As Boolean
        Public Property PricesInclVAT As Boolean
        Public Property AdvPaymentPerc As Decimal
#End Region

#Region "Navigation Properties"
        Public Overridable Property NvAdresses As New ObservableCollection(Of Adress)
        Public Overridable Property NvCurrencies As Currency
        Public Overridable Property NvIncoterms As Incoterm
        Public Overridable Property NvLanguage As Language
        Public Overridable Property NvLegalForms As LegalForm
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
        Public Property Protocol As ICollection(Of Protocol) Implements IProtocolable.Protocol
#End Region
    End Class
End Namespace