﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations
Imports System.Data.Entity.Validation
Imports System.Reflection
Imports System.Text
Imports GalaSoft.MvvmLight
Imports MyERP
Imports MyERP.Interfaces
Imports MyERP.Persistence
''' <summary>
''' This class inherits the Galasoft MVVM ViewModelbase and also implements all necessary Common Properties für Viewmodels
''' </summary>
Public MustInherit Class MyViewModelBase
    Inherits ViewModelBase
    Implements IRequestCloseViewModel


    Public ReadOnly Property CurrentUser As User
        Get
            If SingletonUserRights.Instance.CurrentUser.Id = Nothing Then Return Nothing
            'Return dbo.Users.AsNoTracking.Where(Function(x) x.Id = SingletonUserRights.Instance.CurrentUser.Id).First
            Return Nothing
        End Get
    End Property


#Region "Datacontext"
    Dim vDBO As New myerp_model
    Public Overridable Property dbo As myerp_model
        Get
            Return vDBO
        End Get
        Set(value As myerp_model)
            vDBO = value
            RaisePropertyChanged("dbo")
        End Set
    End Property
    Public Overridable ReadOnly Property _UnitOfWork As New UnitOfWork(New myerp_model)
#End Region


    Public Event RequestClose() Implements IRequestCloseViewModel.RequestClose

    Public Function PerformRequestClose() As Boolean
        RaiseEvent RequestClose()
        Return True
    End Function

    Dim vId As String
    ''' <summary>
    ''' This Id is necessary if a ViewModel can be openend more than 1 time.
    ''' </summary>
    ''' <returns></returns>
    Public Property Id As String
        Get
            Return vId
        End Get
        Set(value As String)
            vId = value
        End Set
    End Property

    'https://www.codeproject.com/Articles/42548/MVVM-and-the-WPF-DataGrid
    Public Shared Function SetCollectionSequence(Of T As ISequencedObject)(ByVal targetCollection As ObservableCollection(Of T)) As ObservableCollection(Of T)
        Dim sequenceNumber = 1

        For Each sequencedObject As ISequencedObject In targetCollection
            sequencedObject.SequenceNumber = sequenceNumber
            sequenceNumber += 1
        Next

        Return targetCollection
    End Function

    Public Function IsCollectionValid(vDisplayMessage As Boolean) As Boolean
        Dim vValidationResults As IEnumerable(Of DbEntityValidationResult) = _UnitOfWork._context.GetValidationErrors()
        If vValidationResults Is Nothing OrElse vValidationResults.Count > 0 Then
            'There are errors
            Dim vStrBuilder As New StringBuilder("Datenprüfung hat folgende Fehler gefunden:")
            vStrBuilder.AppendLine()

            For Each vItem As DbEntityValidationResult In vValidationResults
                For Each vError As DbValidationError In vItem.ValidationErrors
                    vStrBuilder.AppendLine(String.Format("{0} - Feld: {1}", vError.ErrorMessage, vError.PropertyName))
                Next

            Next
            If vDisplayMessage Then MessageBox.Show(vStrBuilder.ToString, "Fehler", MessageBoxButton.OK, MessageBoxImage.Error)
            Return False
        Else
            Return True
        End If
    End Function


    Public ReadOnly Property Zoom As Double
        Get
            If SingletonUserRights.Instance.CurrentUser IsNot Nothing Then
                Return SingletonUserRights.Instance.CurrentUser.Zoom
            Else
                Return 1
            End If
        End Get
    End Property


    Public Function CreateNewView(vType As Type) As Boolean
        If vType Is Nothing Then Return False

        Dim flags As BindingFlags = BindingFlags.[Public] Or BindingFlags.Instance
        Dim vPropInfos As PropertyInfo() = vType.GetProperties(flags)
        For Each vProp As PropertyInfo In vPropInfos
            Try
                CType(vProp.GetCustomAttribute(GetType(DisplayAttribute)), DisplayAttribute).GetName()
                Console.WriteLine("{0} - {1} - {2}", vProp.Name, vProp.PropertyType.ToString, CType(vProp.GetCustomAttribute(GetType(DisplayAttribute)), DisplayAttribute).GetName)
                'AvailableProperties.Add(New Tuple(Of String, String, String)(vProp.Name, vProp.PropertyType.ToString, CType(vProp.GetCustomAttribute(GetType(DisplayAttribute)), DisplayAttribute).GetName.ToString))
            Catch ex As Exception
                Console.WriteLine(vProp.Name)
                Continue For
            End Try


            'Id -System.Guid - Interne ID
            'ArtNr -System.String - Artikelnummer
            'ArticleType -System.Int32 - Artikelart

        Next
    End Function





End Class
