﻿Imports System.Collections.ObjectModel
Imports Model.Interfaces
Imports Model.MyERP2Model

Namespace ViewModel

    Public Class NumberRangeVM
        Inherits MyViewModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp

        Dim _BaseItem As NumberRange

        Public Sub New()
        End Sub
        Friend Sub New(__BaseItem As NumberRange)
            _BaseItem = __BaseItem
        End Sub

#Region "Mapped"
        Public Property Id As Guid
            Get
                Return _BaseItem.Id
            End Get
            Set(value As Guid)
                _BaseItem.Id = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Entity As String
            Get
                Return _BaseItem.Entity
            End Get
            Set(value As String)
                _BaseItem.Entity = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Name As String
            Get
                Return _BaseItem.Name
            End Get
            Set(value As String)
                _BaseItem.Name = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Pattern As String
            Get
                Return _BaseItem.Pattern
            End Get
            Set(value As String)
                _BaseItem.Pattern = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property StartNo As Integer
            Get
                Return _BaseItem.StartNo
            End Get
            Set(value As Integer)
                _BaseItem.StartNo = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LastNo As Integer
            Get
                Return _BaseItem.LastNo
            End Get
            Set(value As Integer)
                _BaseItem.LastNo = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LastDate As Date
            Get
                Return _BaseItem.LastDate
            End Get
            Set(value As Date)
                _BaseItem.LastDate = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IsInUse As Boolean
            Get
                Return _BaseItem.IsInUse
            End Get
            Set(value As Boolean)
                _BaseItem.IsInUse = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IsActive As Boolean
            Get
                Return _BaseItem.IsActive
            End Get
            Set(value As Boolean)
                _BaseItem.IsActive = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
            Get
                Return _BaseItem.DeletedFlag
            End Get
            Set(value As Boolean)
                _BaseItem.DeletedFlag = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
            Get
                Return _BaseItem.DeletedTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.DeletedTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
            Get
                Return _BaseItem.LastUpdateTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.LastUpdateTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
            Get
                Return _BaseItem.CreationTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.CreationTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

    End Class
End Namespace