﻿Imports System.Collections.ObjectModel
Imports Model.Interfaces
Imports Model.MyERP2Model
Imports ViewModel.Interfaces

Namespace ViewModel
    Public Class ObjectNoteVM
        Inherits MyViewModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp
        Implements IProtocolableVM

        Dim _BaseItem As ObjectNote

        Public Sub New()
        End Sub
        Friend Sub New(__BaseItem As ObjectNote)
            _BaseItem = __BaseItem
        End Sub
#Region "Mapped"
        Public Property Id As Guid
            Get
                Return _BaseItem.Id
            End Get
            Set(value As Guid)
                _BaseItem.Id = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property ArtId As Guid?
            Get
                Return _BaseItem.ArtId
            End Get
            Set(value As Guid?)
                _BaseItem.ArtId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Note As String
            Get
                Return _BaseItem.Note
            End Get
            Set(value As String)
                _BaseItem.Note = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Navigation Properties"
        Public Overridable Property NvArticle As ArticleVM
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
            Get
                Return _BaseItem.DeletedFlag
            End Get
            Set(value As Boolean)
                _BaseItem.DeletedFlag = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
            Get
                Return _BaseItem.DeletedTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.DeletedTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
            Get
                Return _BaseItem.LastUpdateTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.LastUpdateTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
            Get
                Return _BaseItem.CreationTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.CreationTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Protocol As ICollection(Of ProtocolVM) Implements IProtocolableVM.Protocol
#End Region

    End Class
End Namespace
