﻿Imports System.Collections.ObjectModel
Imports Model.Interfaces
Imports Model.MyERP2Model

Namespace ViewModel
    Public Class UserVM
        Inherits MyViewModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp

        Dim _BaseItem As User

        Public Sub New()
        End Sub
        Friend Sub New(__BaseItem As User)
            _BaseItem = __BaseItem

            For Each Item As UserUserGroup In __BaseItem.NvUserUserGroup
                NvUserUserGroup.Add(New UserUserGroupVM(Item))
            Next
        End Sub

#Region "Mapped"
        Public Property Id As Guid
            Get
                Return _BaseItem.Id
            End Get
            Set(value As Guid)
                _BaseItem.Id = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Username As String
            Get
                Return _BaseItem.Username
            End Get
            Set(value As String)
                _BaseItem.Username = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Firstname As String
            Get
                Return _BaseItem.Firstname
            End Get
            Set(value As String)
                _BaseItem.Firstname = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Lastname As String
            Get
                Return _BaseItem.Lastname
            End Get
            Set(value As String)
                _BaseItem.Lastname = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Title As String
            Get
                Return _BaseItem.Title
            End Get
            Set(value As String)
                _BaseItem.Title = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Email As String
            Get
                Return _BaseItem.Email
            End Get
            Set(value As String)
                _BaseItem.Email = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Phone As String
            Get
                Return _BaseItem.Phone
            End Get
            Set(value As String)
                _BaseItem.Phone = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Overloads Property Zoom As Double
            Get
                Return _BaseItem.Zoom
            End Get
            Set(value As Double)
                _BaseItem.Zoom = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Navigation Properties"
        Public Overridable Property NvUserUserGroup As New ObservableCollection(Of UserUserGroupVM)
        Public Overridable Property NvUsersSettingsGrid As New ObservableCollection(Of UserSettingsGridVM)
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
            Get
                Return _BaseItem.DeletedFlag
            End Get
            Set(value As Boolean)
                _BaseItem.DeletedFlag = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
            Get
                Return _BaseItem.DeletedTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.DeletedTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
            Get
                Return _BaseItem.LastUpdateTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.LastUpdateTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
            Get
                Return _BaseItem.CreationTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.CreationTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region
    End Class
End Namespace