﻿Imports System.Collections.ObjectModel
Imports GalaSoft.MvvmLight
Imports GalaSoft.MvvmLight.CommandWpf
Imports MyERP2
Imports ViewModel.Interfaces

Namespace ViewModel
    Public Class LoginVM
        Inherits ViewModelBase

        Sub New()
            Username = Environment.UserName.ToLower


            If IsInDesignMode Then
                For i = 1 To 2
                    AvailableServers.Add("Server" & i.ToString)
                    AvailableDatabases.Add("Database" & i.ToString)
                Next
            Else


            End If
            AvailableServers.Add("localhost")
            AvailableServers.Add("anotherServer")
            AvailableDatabases.Add("myerp2_v01")

            SelectedServer = AvailableServers.FirstOrDefault
            SelectedDatabase = AvailableDatabases.FirstOrDefault
        End Sub


        Private _availableServers As New ObservableCollection(Of String)

        Public Property AvailableServers() As ObservableCollection(Of String)
            Get
                Return _availableServers
            End Get
            Set(ByVal value As ObservableCollection(Of String))
                _availableServers = value
                RaisePropertyChanged()
            End Set
        End Property

        Private _availableDatabases As New ObservableCollection(Of String)

        Public Property AvailableDatabases() As ObservableCollection(Of String)
            Get
                Return _availableDatabases
            End Get
            Set(ByVal value As ObservableCollection(Of String))
                _availableDatabases = value
                RaisePropertyChanged()
            End Set
        End Property




        Dim vSelectedServer As String = String.Empty
        Public Property SelectedServer As String
            Get

                Return vSelectedServer
            End Get
            Set(value As String)
                vSelectedServer = value
                RaisePropertyChanged()
            End Set
        End Property

        Dim vSelectedDatabase As String = String.Empty
        Public Property SelectedDatabase As String
            Get
                Return vSelectedDatabase
            End Get
            Set(value As String)
                vSelectedDatabase = value
                RaisePropertyChanged()
            End Set
        End Property


        Dim vUsername As String = String.Empty
        Public Property Username As String
            Get
                Return vUsername
            End Get
            Set(value As String)
                vUsername = value
                RaisePropertyChanged()
            End Set
        End Property

        Dim vPassword As String
        Public Property Password As String
            Get
                Return vPassword
            End Get
            Set(value As String)
                vPassword = value
                RaisePropertyChanged()
            End Set
        End Property

        Public Property CmdCancelLogin As New RelayCommand(Of IClosable)(AddressOf CancelLogin)


        Private Sub CancelLogin(ByVal Window As IClosable)
            'Cancel the login and close the application
            If Window IsNot Nothing Then Window.Close()
            Windows.Application.Current.Shutdown()
        End Sub


        '        Idee für Login Form: 'https://stackoverflow.com/questions/16172462/close-window-from-viewmodel
        'https://stackoverflow.com/questions/7114687/wpf-mvvm-simple-login-to-an-application
        'https://stackoverflow.com/questions/16172462/close-window-from-viewmodel

    End Class
End Namespace
