﻿Imports GalaSoft.MvvmLight.Ioc

Namespace ViewModel
    ''' <summary>
    ''' This class contains static references to all the view models in the
    ''' application and provides an entry point for the bindings.
    ''' </summary>
    Public Class ViewModelLocator
        ''' <summary>
        ''' Initializes a new instance of the ViewModelLocator class.
        ''' </summary>
        Public Sub New()
            SimpleIoc.[Default].Register(Of MainViewModel)()
            SimpleIoc.[Default].Register(Of LoginVM)()

            'Register Entities:
            'SimpleIoc.Default.Register(Of AdressVM)()
            'SimpleIoc.Default.Register(Of ArticleSalesPriceVM)()
            'SimpleIoc.Default.Register(Of ArticleVM)()
            'SimpleIoc.Default.Register(Of ClientVM)()
            'SimpleIoc.Default.Register(Of ContactBaseVM)()
            'SimpleIoc.Default.Register(Of CurrencyVM)()
            'SimpleIoc.Default.Register(Of DiscountGroupVM)()
            'SimpleIoc.Default.Register(Of FilterDefinitionVM)()
            'SimpleIoc.Default.Register(Of FilterItemVM)()
            'SimpleIoc.Default.Register(Of IncotermVM)()
            'SimpleIoc.Default.Register(Of LanguageVM)()
            'SimpleIoc.Default.Register(Of LegalFormVM)()
            'SimpleIoc.Default.Register(Of NumberRangeVM)()
            'SimpleIoc.Default.Register(Of ObjectDescriptionVM)()
            'SimpleIoc.Default.Register(Of ObjectNoteVM)()
            'SimpleIoc.Default.Register(Of ProspectVM)()
            'SimpleIoc.Default.Register(Of ProtocolVM)()
            'SimpleIoc.Default.Register(Of SupplierVM)()
            'SimpleIoc.Default.Register(Of TextDescriptionHeaderVM)()
            'SimpleIoc.Default.Register(Of TextDescriptionVM)()
            'SimpleIoc.Default.Register(Of UnitVM)()
            'SimpleIoc.Default.Register(Of UserGroupRightVM)()
            'SimpleIoc.Default.Register(Of UserGroupVM)()
            'SimpleIoc.Default.Register(Of UserSettingsGridColumnVM)()
            'SimpleIoc.Default.Register(Of UserSettingsGridVM)()
            'SimpleIoc.Default.Register(Of UserUserGroupVM)()
            'SimpleIoc.Default.Register(Of UserVM)()
            'SimpleIoc.Default.Register(Of VatGroupVM)()


            ''Generals:
            'SimpleIoc.Default.Register(Of SearchFormVM)() 'Searchform
            'SimpleIoc.Default.Register(Of DirectSearchVM)() 'Direct Search Usercontrol
            'SimpleIoc.Default.Register(Of FilterFormVM)() 'FilterForm
            'SimpleIoc.Default.Register(Of SelectNumberRangeVM)() 'Selection Form for Numberranges
            'SimpleIoc.Default.Register(Of ItemNotesVM)() 'Form to display notes of an item
            'SimpleIoc.Default.Register(Of DataGridSettings)() 'Form to change view settings of a datagrid

            ''Module Articles:
            'SimpleIoc.Default.Register(Of ArticleMenu)() 'Article Menu
            'SimpleIoc.Default.Register(Of ArticlesOverview)() 'Article Overview
            'SimpleIoc.Default.Register(Of ArticleAddEdit)() 'Article Add/Edit
            'SimpleIoc.Default.Register(Of ArticleStatistics)() 'Article Statistics
            'SimpleIoc.Default.Register(Of TextDescriptionsOverview)() 'Preset Textelements Overview
            'SimpleIoc.Default.Register(Of TextDescriptionOverviewAddEdit)() 'Preset Textelement add/edit
            'SimpleIoc.Default.Register(Of ArticleTextEdit)() ' Article Texts

            ''Module Sales:
            'SimpleIoc.Default.Register(Of SalesMenu)() 'Sales Menu
            'SimpleIoc.Default.Register(Of SalesContacts)() 'Contactmanagement
            'SimpleIoc.Default.Register(Of ContactTypes)() 'Contact Types
            'SimpleIoc.Default.Register(Of ClientStatus)() 'Client Status
            'SimpleIoc.Default.Register(Of DiscountGroups)() 'Discount Groups
            'SimpleIoc.Default.Register(Of ArticleSalesPrices)() ' Article Sales Prices

            ''Module Administration:
            'SimpleIoc.Default.Register(Of AdministrationMenu)() 'Administration Menu
            'SimpleIoc.Default.Register(Of AdminNumberRanges)() 'NumberLogic
            'SimpleIoc.Default.Register(Of AdminUsers)() 'Users
            'SimpleIoc.Default.Register(Of UserUserGroups)() 'User Usergroups
            'SimpleIoc.Default.Register(Of AdminUserGroups)() 'Usergroups
            'SimpleIoc.Default.Register(Of UserGroupAuthorizations)() ' Usergroup Authorizations
            'SimpleIoc.Default.Register(Of Incoterms)() 'Incoterms
            'SimpleIoc.Default.Register(Of Units)() 'Units
            'SimpleIoc.Default.Register(Of Languages)() 'Langugages
            'SimpleIoc.Default.Register(Of ArticleStatus)() 'Article Status Collection
            'SimpleIoc.Default.Register(Of AdressTypes)() 'Adress Types

            ''Module Purchase:
            'SimpleIoc.Default.Register(Of PurchaseMenu)() 'Purchase Menu
            'SimpleIoc.Default.Register(Of SuppliersOverview)() 'Suppliers Overview
            'SimpleIoc.Default.Register(Of SupplierStatistics)() 'Supplier Statistics
            'SimpleIoc.Default.Register(Of SupplierAddEdit)() 'Supplier Add/Edit

            ''Module Accounting:
            'SimpleIoc.Default.Register(Of AccountingMenu)() 'Accouting Menu
            'SimpleIoc.Default.Register(Of LegalForms)() 'Legal Forms
            'SimpleIoc.Default.Register(Of Currencies)() 'Currencies
            'SimpleIoc.Default.Register(Of VATGroups)() 'VAT Groups

            ''Module Stock:
            'SimpleIoc.Default.Register(Of StockMenu)() 'Stock Menu

        End Sub

        Public ReadOnly Property MainModel() As MainViewModel
            Get
                Dim id As String = Guid.NewGuid.ToString
                Dim instance = SimpleIoc.Default.GetInstance(Of MainViewModel)(id)
                instance.VMId = id
                Return instance
            End Get
        End Property

        Public ReadOnly Property Login() As LoginVM
            Get
                Return SimpleIoc.Default.GetInstance(Of LoginVM)
            End Get
        End Property




        '#Region "Generals"

        '        Public ReadOnly Property SearchModel() As VMSearchForm
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMSearchForm)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property DirectSearch() As VMDirectSearch
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMDirectSearch)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property FilterForm() As VMFilterForm
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMFilterForm)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property SelectNumberRange() As VMSelectNumberRange
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMSelectNumberRange)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property ItemNotes() As VMItemNotes
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMItemNotes)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property DataGridSettings() As VMDataGridSettings
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMDataGridSettings)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property
        '#End Region

        '#Region "Article-Module"
        '        Public ReadOnly Property ArticleMenu() As VMArticleMenu
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMArticleMenu)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property
        '        Public ReadOnly Property ArticlesOverview() As VMArticlesOverview
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMArticlesOverview)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property ArticleAddEdit() As VMArticleAddEdit
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMArticleAddEdit)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property ArticleStatistics() As VMArticleStatistics
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMArticleStatistics)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property TextDescriptionsOverview() As VMTextDescriptionsOverview
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMTextDescriptionsOverview)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property TextDescriptionOverviewAddEdit() As VMTextDescriptionOverviewAddEdit
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMTextDescriptionOverviewAddEdit)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property ArticleTextEdit() As VMArticleTextEdit
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMArticleTextEdit)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property
        '#End Region

        '#Region "Sales-Module"
        '        Public ReadOnly Property SalesMenu() As VMSalesMenu
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMSalesMenu)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property SalesContacts() As VMSalesContacts
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMSalesContacts)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property ContactTypes() As VMContactTypes
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMContactTypes)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property ClientStatus() As VMClientStatus
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMClientStatus)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property DiscountGroups() As VMDiscountGroups
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMDiscountGroups)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property ArticleSalesPrices() As VMArticleSalesPrices
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMArticleSalesPrices)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '#End Region

        '#Region "Purchase-Module"
        '        Public ReadOnly Property PurchaseMenu() As VMPurchaseMenu
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMPurchaseMenu)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property SuppliersOverview() As VMSuppliersOverview
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMSuppliersOverview)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property SupplierAddEdit() As VMSupplierAddEdit
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMSupplierAddEdit)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property SupplierStatistics() As VMSupplierStatistics
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMSupplierStatistics)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '#End Region

        '#Region "Accouting"
        '        Public ReadOnly Property AccountingMenu() As VMAccountingMenu
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMAccountingMenu)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property LegalForms() As VMLegalForms
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMLegalForms)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property Currencies() As VMCurrencies
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMCurrencies)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property VATGroups() As VMVATGroups
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMVATGroups)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '#End Region

        '#Region "Administration-Module"

        '        Public ReadOnly Property AdministrationMenu() As VMAdministrationMenu
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMAdministrationMenu)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property AdminNumberRanges() As VMAdminNumberRanges
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMAdminNumberRanges)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property AdminUsers() As VMAdminUsers
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMAdminUsers)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property AdminUserUserGroups() As VMUserUserGroups
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMUserUserGroups)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property AdminUserGroups() As VMAdminUserGroups
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMAdminUserGroups)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property AdminUserGroupAuthorizations() As VMUserGroupAuthorizations
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMUserGroupAuthorizations)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property Incoterms() As VMIncoterms
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMIncoterms)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property Units() As VMUnits
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMUnits)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property Languages() As VMLanguages
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMLanguages)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property ArticleStatus() As VMArticleStatus
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMArticleStatus)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property

        '        Public ReadOnly Property AdressTypes() As VMAdressTypes
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMAdressTypes)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property
        '#End Region

        '#Region "Stock-Module"

        '        Public ReadOnly Property StockMenu() As VMStockMenu
        '            Get
        '                Dim id As String = Guid.NewGuid.ToString
        '                Dim instance = SimpleIoc.Default.GetInstance(Of VMStockMenu)(id)
        '                instance.Id = id
        '                Return instance
        '            End Get
        '        End Property
        '#End Region



        Public Shared Sub Cleanup()
            SimpleIoc.Default.Reset()
        End Sub
    End Class
End Namespace